/**
 *
 */
package de.intevation.gnv.state;

import java.io.OutputStream;
import java.util.Collection;

import org.w3c.dom.Document;

import de.intevation.artifacts.CallContext;
import de.intevation.gnv.state.exception.StateException;

/**
 * @author Tim Englich <tim.englich@intevation.de>
 * 
 */
public interface OutputState extends State {

    /**
     * Returns the Rendered Result of an State.
     * 
     * @param outputMode
     *            The Mode that should be produces (Chart, Map, ...)
     * @return The Bytecode of the Result
     * @throws StateException
     */
    public void out(
        Document format,
        Collection<InputData> inputData,
        OutputStream outputStream,
        String uuid,
        CallContext callContext
    ) throws StateException;

    /**
     * Delivers the provided OutputModes of an State
     * 
     * @return the provided OutputModes of an State
     */
    public Collection<OutputMode> getOutputModes();
}
